#include <stdio.h>

#include "mv.h"

/* 
 * This version includes an extra index vector; the intent here is to
 * generate a "good" value for the cache, and use ka to select the
 * rows in this "better" order.  Computing ka is hard though; the
 * code currently in here is not what you want.  It still gives
 * slightly better performance on the O2000 than mv1 for 
 * -n 64000 -n 40 -matrix 2
 */
void mv_( ia, ja, ka,  a, x, y, n_ptr )
int    *ia, *ja, *ka, *n_ptr;
double *a, *x, *y;
{
    double     sum;
    int        i, jrow,j,ncol,shift,n=*n_ptr, row;

    /* x    = x + shift; */ 
    shift = 1; /* shift for Fortran start by 1 indexing */
    x = x - shift;
    for ( i=0; i<n; i++ ) {
	row  = ka[i];
	jrow = ia[row];
	ncol = ia[row+1] - jrow;
	jrow = jrow - shift;
	sum  = 0.0;
	/* while (ncol--) sum += *v++ * x[*ja++]; */
	for ( j=0; j<ncol; j++) {
	    sum += a[jrow]*x[ja[jrow]]; jrow++;
	}
	y[row] = sum;
    }
}

int mvextra_( ia, ja, a, n_ptr )
int *ia, *ja, *n_ptr;
double *a;
{
    return *n_ptr + 1;
}

/*
 * This is a silly way to compute ka. 
 */
void mvsetup_( ia, ja, ka, a, n_ptr )
int *ia, *ja, *ka, *n_ptr;
double *a;
{
    int i, j,  n = *n_ptr, *used, jrow, ncol, maxcol, col, cnt;

    /* Order the rows by taking the furthest away, unused row */
    used = (int *)malloc( n * sizeof(int) );
    if (!used) {
	fprintf( stderr, "Could not allocated %d in setup\n", n );
	exit( 1 );
    }
    for (i=0; i<n; i++) used[i] = 0;

    cnt = 0;
    ka[cnt++] = 0;
    used[0] = 1;
    for (i=0; i<n; i++) {
	jrow = ia[i];
	ncol = ia[i+1] - jrow;
	maxcol = -i;
	for (j=0; j<ncol; j++) {
	    col = ja[jrow];
	    if (col == i + 1) {
		maxcol = col - i;
		break;
	    }
	    if (used[col] == 0) {
		if (col > maxcol + i)
		    maxcol = col - i;
		else if(col < maxcol + i) 
		    maxcol = col - i;
	    }
	}
	col = maxcol + i;
	if (col && used[col] == 0) {
	    /* printf( "setting ka[%d] to %d\n", cnt, col ); */
	    ka[cnt++] = col;
	    used[col] = 1;
	}
    }
    for (i=0; i<n; i++) {
	if (!used[i]) {
	    /* printf( "setting ka[%d] to %d\n", cnt, i ); */
	    ka[cnt++] = i;
	    if (cnt >= n) break;
	}
    }
    
    free( used );
}

void mvname_( str, ln )
char *str;
int  ln;
{
    strncpy( str, "C AIJ with permuted row ordering", ln - 1 );
}

#ifndef FLAGS
#define FLAGS "Unknown"
#endif
void mvflags_(str, ln )
char *str;
int  ln;
{
    strncpy( str, FLAGS, ln - 1 );
}
